<?php

namespace Services;

use Zeedhi\Framework\DTO\Response\Error;
use \Doctrine\ORM\EntityManager;

class PlanejamentoProducaoService {

	const DELETE_RECEITAS  			= "DELETE RECCKLISTPRODINF WHERE CDFILIAL = :CDFILIAL AND NRCKLISTPRODINF = :NRCKLISTPRODINF";
	const DELETE_DESTINOS  			= "DELETE DESTCKLISTPRODINF WHERE CDFILIAL = :CDFILIAL AND NRRECCKLISTPRODINF = :NRRECCKLISTPRODINF";
	const DELETE_JUSREJDESP 		= "DELETE JUSREJDESP WHERE CDFILIAL = :CDFILIAL AND NRRECCKLISTPRODINF = :NRRECCKLISTPRODINF";
	const DELETE_CHECKLIST 			= "DELETE CKLISTPRODINF WHERE CDFILIAL = :CDFILIAL AND NRCKLISTPRODINF = :NRCKLISTPRODINF";
	const SELECT_RECEITAS  			= "SELECT NRRECCKLISTPRODINF FROM RECCKLISTPRODINF WHERE CDFILIAL = :CDFILIAL AND NRCKLISTPRODINF = :NRCKLISTPRODINF";
	const SELECT_DESTINOS  			= "SELECT CDFILIAL, NRRECCKLISTPRODINF, NRDESTCKLISTPRODINF, QTRECEITAINF  FROM DESTCKLISTPRODINF WHERE CDFILIAL = :CDFILIAL AND NRRECCKLISTPRODINF = :NRRECCKLISTPRODINF";
	const SELECT_SUM_QTD_DESTINOS  	= "SELECT SUM(ROUND(QTRECEITAINF, 3)) AS SUM_QTD FROM DESTCKLISTPRODINF WHERE CDFILIAL = :CDFILIAL AND NRRECCKLISTPRODINF = :NRRECCKLISTPRODINF";
	const UPDATE_RECEITA		  	= "UPDATE RECCKLISTPRODINF SET QTRECEITAINF = :QTRECEITAINF WHERE CDFILIAL = :CDFILIAL AND NRRECCKLISTPRODINF = :NRRECCKLISTPRODINF";

	protected $connection;
	protected $entityManager;

	public function __construct(EntityManager $entityManager) {
		$this->connection = $entityManager->getConnection();
		$this->entityManager = $entityManager;
	}

	public function getDeleteReceitas(){
		return self::DELETE_RECEITAS;
	}
	public function getDeleteDestinos(){
		return self::DELETE_DESTINOS;
	}
	public function getDeleteChecklist(){
		return self::DELETE_CHECKLIST;
	}	
	public function getSelectReceitas(){
		return self::SELECT_RECEITAS;
	}
	public function getSelectSumDestinos(){
		return self::SELECT_SUM_QTD_DESTINOS;
	}
	public function getSelectDestinos(){
		return self::SELECT_DESTINOS;
	}
	public function getDeleteJustificativa(){
		return self::DELETE_JUSREJDESP;
	}
	public function getUpdateReceita(){
		return self::UPDATE_RECEITA;
	}

	private function getQueryByName($name){
		$query = "";
		switch ($name) {
			case 'DELETE_RECEITAS':
				$query = $this->getDeleteReceitas();
				break;
			case 'DELETE_DESTINOS':
				$query = $this->getDeleteDestinos();
				break;
			case 'DELETE_JUSREJDESP':
				$query = $this->getDeleteJustificativa();
				break;
			case 'SELECT_RECEITAS':
				$query = $this->getSelectReceitas();
				break;	
			case 'SELECT_SUM_QTD_DESTINOS':
				$query = $this->getSelectSumDestinos();
				break;
			case 'SELECT_DESTINOS':
				$query = $this->getSelectDestinos();
				break;
			case 'UPDATE_RECEITA':
				$query = $this->getUpdateReceita();
				break;
			case 'DELETE_CHECKLIST':
				$query = $this->getDeleteChecklist();
				break;
		}
		return $query;
	}

	public function find($params, $queryName) {
		$query = $this->getQueryByName($queryName);
		$callback = array();
		if(!empty($query)){
			//Execute query
			$callback = $this->connection->fetchAll($query, $params);
		}
		return $callback;
	}
	public function delete($params, $queryName) {
		$sql = $this->getQueryByName($queryName);
		$this->connection->executeQuery($sql, $params);
	}
	public function update($params, $queryName) {
		$sql = $this->getQueryByName($queryName);
		$this->connection->executeQuery($sql, $params);
	}

}