<?php

namespace Services;

use Zeedhi\Framework\DTO\Response\Error;
use \Doctrine\ORM\EntityManager;

class PrevisaoConsumoService {

	const DELETE_PREVCONSINF		= "DELETE PREVCONSINF WHERE CDFILIAL = :CDFILIAL AND NRPREVCONSINF = :NRPREVCONSINF";
	const DELETE_INSUMOPREVCONSINF	= "DELETE INSUMOPREVCONSINF WHERE NRPREVCONSINF = :NRPREVCONSINF";
	const DELETE_DESTPREVCONSINF    = "DELETE DESTPREVCONSINF WHERE CDFILIAL = :CDFILIAL AND NRINSUMOPREVCONSINF = :NRINSUMOPREVCONSINF";
	const SELECT_INSUMOPREVCONSINF	= "SELECT NRINSUMOPREVCONSINF FROM INSUMOPREVCONSINF WHERE NRPREVCONSINF = :NRPREVCONSINF";

	protected $connection;
	protected $entityManager;

	public function __construct(EntityManager $entityManager) {
		$this->connection = $entityManager->getConnection();
		$this->entityManager = $entityManager;
	}

	public function getDeletePrevisao(){
		return self::DELETE_PREVCONSINF;
	}
	public function getDeleteInsumo(){
		return self::DELETE_INSUMOPREVCONSINF;
	}
	public function getDeleteDestino(){
		return self::DELETE_DESTPREVCONSINF;
	}	
	public function getSelectInsumos(){
		return self::SELECT_INSUMOPREVCONSINF;
	}

	private function getQueryByName($name){
		$query = "";
		switch ($name) {
			case 'DELETE_PREVCONSINF':
				$query = $this->getDeletePrevisao();
				break;
			case 'DELETE_INSUMOPREVCONSINF':
				$query = $this->getDeleteInsumo();
				break;
			case 'DELETE_DESTPREVCONSINF':
				$query = $this->getDeleteDestino();
				break;
			case 'SELECT_INSUMOPREVCONSINF':
				$query = $this->getSelectInsumos();
				break;	
		}
		return $query;
	}

	public function find($params, $queryName) {
		$query = $this->getQueryByName($queryName);
		$callback = array();
		if(!empty($query)){
			//Execute query
			$callback = $this->connection->fetchAll($query, $params);
		}
		return $callback;
	}
	public function delete($params, $queryName) {
		$sql = $this->getQueryByName($queryName);
		$this->connection->executeQuery($sql, $params);
	}
	public function update($params, $queryName) {
		$sql = $this->getQueryByName($queryName);
		$this->connection->executeQuery($sql, $params);
	}

}